import * as echarts from 'echarts';
import { Vue } from 'vue-property-decorator';
declare type ECharts = ReturnType<typeof echarts.init>;
export default class BaseCharts extends Vue {
    readonly chartData: any | undefined;
    private _uid;
    protected chart: ECharts | null;
    resize_ele_width: number;
    resize_ele_height: number;
    $refs: {
        chart: HTMLDivElement;
    };
    get options(): {};
    mounted(): void;
    destory(): void;
    initChart(): void;
    updateWidth(): void;
    onResize(): void;
    chartOnClick(): void;
    render(CreateElement: any): any;
}
export {};
