"use strict";

var _interopRequireWildcard = require("F:/vue-create-web/node_modules/@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("F:/vue-create-web/node_modules/@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/createClass"));

var _inherits2 = _interopRequireDefault(require("F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/inherits"));

var _createSuper2 = _interopRequireDefault(require("F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/createSuper"));

var _tslib = require("tslib");

var echarts = _interopRequireWildcard(require("echarts"));

var _vuePropertyDecorator = require("vue-property-decorator");

var resizeCache = {};

var resizeFn = function resizeFn() {
  for (var key in resizeCache) {
    if (Object.prototype.hasOwnProperty.call(resizeCache, key)) {
      var element = resizeCache[key];
      element.updateWidth();
    }
  }

  setTimeout(resizeFn, 500);
};

var BaseCharts = /*#__PURE__*/function (_Vue) {
  (0, _inherits2.default)(BaseCharts, _Vue);

  var _super = (0, _createSuper2.default)(BaseCharts);

  function BaseCharts() {
    var _this;

    (0, _classCallCheck2.default)(this, BaseCharts);
    _this = _super.apply(this, arguments);
    _this.resize_ele_width = 0;
    _this.resize_ele_height = 0;
    return _this;
  }

  (0, _createClass2.default)(BaseCharts, [{
    key: "mounted",
    value: function mounted() {
      resizeCache[this._uid] = this;
      this.resize_ele_width = this.$el.clientWidth;
      this.resize_ele_height = this.$el.clientHeight;
      this.initChart();
    }
  }, {
    key: "destory",
    value: function destory() {
      delete resizeCache[this._uid];
    }
  }, {
    key: "initChart",
    value: function initChart() {
      if (this.$refs.chart) {
        this.chart = echarts.init(this.$refs.chart);
        this.chart.setOption(this.options);
        this.chart.on('click', this.chartOnClick);
      }
    }
  }, {
    key: "updateWidth",
    value: function updateWidth() {
      this.resize_ele_width = this.$el.clientWidth;
      this.resize_ele_height = this.$el.clientHeight;
    }
  }, {
    key: "onResize",
    value: function onResize() {
      if (this.chart) this.chart.resize();
    }
  }, {
    key: "chartOnClick",
    value: function chartOnClick() {}
  }, {
    key: "render",
    value: function render(CreateElement) {
      return CreateElement('div', {
        ref: 'chart',
        style: {
          width: '100%',
          height: '100%'
        }
      });
    }
  }, {
    key: "options",
    get: function get() {
      return {};
    }
  }]);
  return BaseCharts;
}(_vuePropertyDecorator.Vue);

(0, _tslib.__decorate)([(0, _vuePropertyDecorator.Prop)()], BaseCharts.prototype, "chartData", void 0);
BaseCharts = (0, _tslib.__decorate)([(0, _vuePropertyDecorator.Component)({
  watch: {
    options: function options() {
      if (this.chart) this.chart.setOption(this.options);
    },
    chartData: function chartData() {
      if (this.chart) this.chart.setOption(this.options);
    },
    resize_ele_width: function resize_ele_width() {
      if (this.onResize) this.onResize();
    },
    resize_ele_height: function resize_ele_height() {
      if (this.onResize) this.onResize();
    }
  }
})], BaseCharts);
var _default = BaseCharts;
exports.default = _default;
resizeFn();